
#ifndef __ZEGO_EXPRESS_ERRCODE_H__
#define __ZEGO_EXPRESS_ERRCODE_H__

#define ZEGO_EXPRESS_MODULE_COMMON         (0)
#define ZEGO_EXPRESS_MODULE_ENGINE         (1)
#define ZEGO_EXPRESS_MODULE_ROOM           (2)
#define ZEGO_EXPRESS_MODULE_PUBLISHER      (3)
#define ZEGO_EXPRESS_MODULE_PLAYER         (4)
#define ZEGO_EXPRESS_MODULE_MIXER          (5)
#define ZEGO_EXPRESS_MODULE_DEVICE         (6)
#define ZEGO_EXPRESS_MODULE_PREPROCESS     (7)
#define ZEGO_EXPRESS_MODULE_MEDIAPLAYER    (8)
#define ZEGO_EXPRESS_MODULE_IM             (9)
#define ZEGO_EXPRESS_MODULE_RECORD         (10)
#define ZEGO_EXPRESS_MODULE_CUSTOMVIDEOIO  (11)
#define ZEGO_EXPRESS_MODULE_CUSTOMAUDIOIO  (12)

/** 执行成功 */
#define ZEGO_ERRCODE_COMMON_SUCCESS                                                         0

/** 未初始化引擎，在调用非静态方法前需要先初始化引擎 */
#define ZEGO_ERRCODE_COMMON_ENGINE_NOT_CREATE                                               1000001

/** 未登陆房间, 在调用推流或拉流前，请先登陆房间 */
#define ZEGO_ERRCODE_COMMON_NOT_LOGIN_ROOM                                                  1000002

/** 引擎未启动，请先调用预览/推流/拉流接口 */
#define ZEGO_ERRCODE_COMMON_ENGINE_NOT_STARTED                                              1000003

/** 调用了当前平台不支持的接口, 例如在非 Android 平台调用了设置 Android 上下文环境的接口 */
#define ZEGO_ERRCODE_COMMON_UNSUPPORTED_PLATFORM                                            1000006

/** 无效的 Android 上下文环境 */
#define ZEGO_ERRCODE_COMMON_INVALID_ANDROID_ENVIRONMENT                                     1000007

/** 已调用 `setEventHandler` 设置了 handler，请勿重复设置；若需要重复设置，请先调用 `setEventHandler` 将之前的 handler 置空 */
#define ZEGO_ERRCODE_COMMON_EVENT_HANDLER_EXISTS                                            1000008

/** 此 SDK 没有包含此模块功能，请联系技术支持提供 */
#define ZEGO_ERRCODE_COMMON_SDK_NO_MODULE                                                   1000010

/** 输入流 ID 超长, 最大支持输入 256 个字符 */
#define ZEGO_ERRCODE_COMMON_STREAM_ID_TOO_LONG                                              1000014

/** 输入流 ID 为空 */
#define ZEGO_ERRCODE_COMMON_STREAM_ID_NULL                                                  1000015

/** 输入流 ID 包含非法字符 */
#define ZEGO_ERRCODE_COMMON_STREAM_ID_INVALID_CHARACTER                                     1000016

/** 该 AppID 已经下线 */
#define ZEGO_ERRCODE_COMMON_APP_OFFLINE_ERROR                                               1000037

/** 后台配置有错误，请检查 APP 配置项 */
#define ZEGO_ERRCODE_COMMON_APP_FLEXIABLE_CONFIG_ERROR                                      1000038

/** CDN 地址有误，请检查支持的协议和格式 */
#define ZEGO_ERRCODE_COMMON_CDN_URL_INVALID                                                 1000055

/** DNS 解析失败，请检查网络配置 */
#define ZEGO_ERRCODE_COMMON_DNS_RESOLVE_ERROR                                               1000060

/** 服务器调度异常，请联系技术支持解决 */
#define ZEGO_ERRCODE_COMMON_DISPATCH_ERROR                                                  1000065

/** 内部空指针错误，请联系技术支持解决 */
#define ZEGO_ERRCODE_COMMON_INNER_NULLPTR                                                   1000090

/** AppID 不能为 0，请检查 AppID 是否正确 */
#define ZEGO_ERRCODE_ENGINE_APPID_ZERO                                                      1001000

/** 输入 AppSign 长度必须为 64 字节 */
#define ZEGO_ERRCODE_ENGINE_APPSIGN_INVALID_LENGTH                                          1001001

/** 输入 AppSign 包含非法字符, 仅支持'0'-'9','a'-'f','A'-'F' */
#define ZEGO_ERRCODE_ENGINE_APPSIGN_INVALID_CHARACTER                                       1001002

/** 输入 AppSign 为空 */
#define ZEGO_ERRCODE_ENGINE_APPSIGN_NULL                                                    1001003

/** 认证失败，请检查 AppID 是否正确；或是否在没有向 ZEGO 申请上线的情况下选择了正式环境初始化 */
#define ZEGO_ERRCODE_ENGINE_APPID_INCORRECT_OR_NOT_ONLINE                                   1001004

/** AppSign 认证失败，请检查 AppSign 是否正确 */
#define ZEGO_ERRCODE_ENGINE_APPSIGN_INCORRECT                                               1001005

/** 日志没有写入权限 */
#define ZEGO_ERRCODE_ENGINE_LOG_NO_WRITE_PERMISSION                                         1001014

/** 输入日志的路径超长 */
#define ZEGO_ERRCODE_ENGINE_LOG_PATH_TOO_LONG                                               1001015

/** 登陆房间数量超过上限，当前仅支持同时登陆 1 个房间 */
#define ZEGO_ERRCODE_ROOM_COUNT_EXCEED                                                      1002001

/** 输入用户 ID 为空 */
#define ZEGO_ERRCODE_ROOM_USER_ID_NULL                                                      1002005

/** 输入用户 ID 包含非法字符 */
#define ZEGO_ERRCODE_ROOM_USER_ID_INVALID_CHARACTER                                         1002006

/** 输入用户 ID 超长，最大支持输入 64 个字符 */
#define ZEGO_ERRCODE_ROOM_USER_ID_TOO_LONG                                                  1002007

/** 输入用户名为空 */
#define ZEGO_ERRCODE_ROOM_USER_NAME_NULL                                                    1002008

/** 输入用户名包含非法字符 */
#define ZEGO_ERRCODE_ROOM_USER_NAME_INVALID_CHARACTER                                       1002009

/** 输入用户 ID 超长，最大支持输入 256 个字符 */
#define ZEGO_ERRCODE_ROOM_USER_NAME_TOO_LONG                                                1002010

/** 输入房间 ID 为空 */
#define ZEGO_ERRCODE_ROOM_ROOMID_NULL                                                       1002011

/** 输入房间 ID 包含非法字符 */
#define ZEGO_ERRCODE_ROOM_ROOMID_INVALID_CHARACTER                                          1002012

/** 输入房间 ID 超长，最大支持输入 128 个字符 */
#define ZEGO_ERRCODE_ROOM_ROOMID_TOO_LONG                                                   1002013

/** 登陆房间失败，可能是由于网络原因 */
#define ZEGO_ERRCODE_ROOM_ERROR_CONNECT_FAILED                                              1002030

/** 登陆房间超时，可能是由于网络原因 */
#define ZEGO_ERRCODE_ROOM_ERROR_LOGIN_TIMEOUT                                               1002031

/** 登陆房间鉴权失败 */
#define ZEGO_ERRCODE_ROOM_ERROR_AUTHENTICATION_FAILED                                       1002033

/** 登陆房间的用户数超过该房间配置的最大用户数量限制 */
#define ZEGO_ERRCODE_ROOM_ERROR_EXCEED_MAXIMUM_MEMBER                                       1002034

/** 用户被踢出房间，可能是相同用户 ID 在其他设备登陆 */
#define ZEGO_ERRCODE_ROOM_KICKED_OUT                                                        1002050

/** 网络原因导致房间连接临时中断，正在重试 */
#define ZEGO_ERRCODE_ROOM_CONNECT_TEMPORARY_BROKEN                                          1002051

/** 房间连接断开，可能是由于网络原因导致 */
#define ZEGO_ERRCODE_ROOM_DISCONNECT                                                        1002052

/** 重试登录房间超过最大的重试时间 */
#define ZEGO_ERRCODE_ROOM_RETRY_TIMEOUT                                                     1002053

/** 业务后台发出了踢出房间信令，请查看被踢原因 */
#define ZEGO_ERRCODE_ROOM_MANUAL_KICKED_OUT                                                 1002055

/** 系统内部异常导致房间登陆失败 */
#define ZEGO_ERRCODE_ROOM_INNER_ERROR                                                       1002099

/** 推流失败，有可能是推流没有数据 */
#define ZEGO_ERRCODE_PUBLISHER_PUBLISH_STREAM_FAILED                                        1003001

/** 码率设置有误，请检查单位(kbps)是否有误 */
#define ZEGO_ERRCODE_PUBLISHER_BITRATE_INVALID                                              1003002

/** 推流流控参数设置有误 */
#define ZEGO_ERRCODE_PUBLISHER_TRAFFIC_MODE_INVALID                                         1003005

/** 推流临时中断，正在重试 */
#define ZEGO_ERRCODE_PUBLISHER_ERROR_NETWORK_INTERRUPT                                      1003020

/** 推流失败，该用户已在推流 */
#define ZEGO_ERRCODE_PUBLISHER_ERROR_ALREADY_DO_PUBLISH                                     1003023

/** 推流失败，该流被后台系统配置为禁止推送 */
#define ZEGO_ERRCODE_PUBLISHER_ERROR_SERVER_FORBID                                          1003025

/** 推流失败，房间内已有相同的流 */
#define ZEGO_ERRCODE_PUBLISHER_ERROR_REPETITIVE_PUBLISH_STREAM                              1003028

/** 与 RTMP 服务器连接中断，请检查网络或推流地址是否异常 */
#define ZEGO_ERRCODE_PUBLISHER_RTMP_SERVER_DISCONNECT                                       1003029

/** 更新转推 CDN 状态失败，请检测 URL 是否合法 */
#define ZEGO_ERRCODE_PUBLISHER_UPDATE_CDN_TARGET_ERROR                                      1003040

/** 发送 SEI 失败，data 为空 */
#define ZEGO_ERRCODE_PUBLISHER_SEI_DATA_NULL                                                1003043

/** 发送 SEI 失败，data 超长，最大支持 4096 个字符 */
#define ZEGO_ERRCODE_PUBLISHER_SEI_DATA_TOO_LONG                                            1003044

/** 流附加信息为空 */
#define ZEGO_ERRCODE_PUBLISHER_EXTRA_INFO_NULL                                              1003050

/** 流附加信息超长，最大为 1024 个字符 */
#define ZEGO_ERRCODE_PUBLISHER_EXTRA_INFO_TOO_LONG                                          1003051

/** 更新流附加信息失败，请检查网络连接 */
#define ZEGO_ERRCODE_PUBLISHER_UPDATE_EXTRA_INFO_FAILED                                     1003053

/** 推流水印路径为空 */
#define ZEGO_ERRCODE_PUBLISHER_WATERMARK_URL_NULL                                           1003055

/** 推流水印路径超长，最大为 1024 个字符 */
#define ZEGO_ERRCODE_PUBLISHER_WATERMARK_URL_TOO_LONG                                       1003056

/** 推流水印格式错误，仅支持 jpg 和 png 格式 */
#define ZEGO_ERRCODE_PUBLISHER_WATERMARK_URL_INVALID                                        1003057

/** 推流水印布局有误，布局区域不能超出编码分辨率大小 */
#define ZEGO_ERRCODE_PUBLISHER_WATERMARK_LAYOUT_INVALID                                     1003058

/** 系统内部异常导致推流失败 */
#define ZEGO_ERRCODE_PUBLISHER_INNER_ERROR                                                  1003099

/** 推流失败，有可能是拉流没有数据 */
#define ZEGO_ERRCODE_PLAYER_PLAY_STREAM_FAILED                                              1004001

/** 拉流超过最大的数量，目前支持最多 12 路拉流（如有需要可联系技术支持扩容） */
#define ZEGO_ERRCODE_PLAYER_COUNT_EXCEED                                                    1004010

/** 拉流临时中断，正在重试 */
#define ZEGO_ERRCODE_PLAYER_ERROR_NETWORK_INTERRUPT                                         1004020

/** 系统内部异常导致拉流失败 */
#define ZEGO_ERRCODE_PLAYER_INNER_ERROR                                                     1004099

/** 无混流服务，请联系技术支持开启 */
#define ZEGO_ERRCODE_MIXER_NO_SERVICES                                                      1005000

/** 混流任务 ID 为空 */
#define ZEGO_ERRCODE_MIXER_TASK_ID_NULL                                                     1005001

/** 混流任务 ID 超长，最大为 256 个字符 */
#define ZEGO_ERRCODE_MIXER_TASK_ID_TOO_LONG                                                 1005002

/** 混流任务 ID 中含有非法字符 */
#define ZEGO_ERRCODE_MIXER_TASK_ID_INVALID_CHARACTER                                        1005003

/** 混流任务配置未指定输出 */
#define ZEGO_ERRCODE_MIXER_NO_OUTPUT_TARGET                                                 1005005

/** 混流输出目标有误，请检查是否 target 为 streamID 时，传入了非法字符 */
#define ZEGO_ERRCODE_MIXER_OUTPUT_TARGET_INVALID                                            1005006

/** 启动混流任务请求失败，可能是由于网络原因 */
#define ZEGO_ERRCODE_MIXER_START_REQUEST_ERROR                                              1005010

/** 停止混流任务请求失败，可能是由于网络原因 */
#define ZEGO_ERRCODE_MIXER_STOP_REQUEST_ERROR                                               1005011

/** 该混流任务必须由该任务的启动用户执行停止操作 */
#define ZEGO_ERRCODE_MIXER_NOT_OWNER_STOP_MIXER                                             1005012

/** 混流任务启动过于频繁 */
#define ZEGO_ERRCODE_MIXER_START_QPS_OVERLOAD                                               1005015

/** 混流任务停止过于频繁 */
#define ZEGO_ERRCODE_MIXER_STOP_QPS_OVERLOAD                                                1005016

/** 混流任务输入流列表为空 */
#define ZEGO_ERRCODE_MIXER_INPUT_LIST_INVALID                                               1005020

/** 混流任务输出列表为空 */
#define ZEGO_ERRCODE_MIXER_OUTPUT_LIST_INVALID                                              1005021

/** 混流任务视频配置无效 */
#define ZEGO_ERRCODE_MIXER_VIDEO_CONFIG_INVALID                                             1005023

/** 混流任务音频配置无效，请检查是否使用了不支持的编解码 */
#define ZEGO_ERRCODE_MIXER_AUDIO_CONFIG_INVALID                                             1005024

/** 超过最大的输入流数量，最大支持 9 个输入流 */
#define ZEGO_ERRCODE_MIXER_EXCEED_MAX_INPUT_COUNT                                           1005025

/** 输入流不存在 */
#define ZEGO_ERRCODE_MIXER_INPUT_STREAM_NOT_EXISTS                                          1005026

/** 混流输入参数错误，可能是输入流的布局超过画布范围 */
#define ZEGO_ERRCODE_MIXER_INPUT_PARAMETERS_ERROR                                           1005027

/** 超过最大的输出流数量，最大支持 3 个输出流 */
#define ZEGO_ERRCODE_MIXER_EXCEED_MAX_OUTPUT_COUNT                                          1005030

/** 混流认证失败 */
#define ZEGO_ERRCODE_MIXER_AUTHENTICATION_FAILED                                            1005050

/** 输入水印为空 */
#define ZEGO_ERRCODE_MIXER_WATERMARK_NULL                                                   1005061

/** 输入水印参数错误，可能是布局超过画布范围 */
#define ZEGO_ERRCODE_MIXER_WATERMARK_PARAMETERS_ERROR                                       1005062

/** 输入水印 URL 非法，必须以 `preset-id://` 开头且需要是 `.jpg` 或 `.png` 结尾 */
#define ZEGO_ERRCODE_MIXER_WATERMARK_URL_INVALID                                            1005063

/** 输入背景图 URL 非法，必须以 preset-id://开头且需要是 `.jpg` 或 `.png` 结尾 */
#define ZEGO_ERRCODE_MIXER_BACKGROUND_IMAGE_URL_INVALID                                     1005067

/** 未找到自动混流服务器，请联系技术支持配置 */
#define ZEGO_ERRCODE_MIXER_AUTO_MIX_STREAM_SERVER_NOT_FOUND                                 1005070

/** 混流内部错误 */
#define ZEGO_ERRCODE_MIXER_INNER_ERROR                                                      1005099

/** 设备一般错误 */
#define ZEGO_ERRCODE_DEVICE_ERROR_TYPE_GENERIC                                              1006001

/** 设备 ID 不存在 */
#define ZEGO_ERRCODE_DEVICE_ERROR_TYPE_INVALID_ID                                           1006002

/** 没有设备权限，请检查摄像头或麦克风的权限 */
#define ZEGO_ERRCODE_DEVICE_ERROR_TYPE_NO_AUTHORIZATION                                     1006003

/** 设备采集帧率为 0 */
#define ZEGO_ERRCODE_DEVICE_ERROR_TYPE_ZERO_FPS                                             1006004

/** 设备被占用 */
#define ZEGO_ERRCODE_DEVICE_ERROR_TYPE_IN_USE_BY_OTHER                                      1006005

/** 设备被拔出 */
#define ZEGO_ERRCODE_DEVICE_ERROR_TYPE_UNPLUGGED                                            1006006

/** 设备需要重启 */
#define ZEGO_ERRCODE_DEVICE_ERROR_TYPE_REBOOT_REQUIRED                                      1006007

/** 设备媒体丢失 */
#define ZEGO_ERRCODE_DEVICE_ERROR_MEDIA_SERVICES_LOST                                       1006008

/** 释放释放设备列表时，列表为空 */
#define ZEGO_ERRCODE_DEVICE_FREE_DEVICE_LIST_NULL                                           1006020

/** 设备内部错误 */
#define ZEGO_ERRCODE_DEVICE_INNER_ERROR                                                     1006099

/** 前处理模块未知错误，请联系 ZEGO 技术人员 */
#define ZEGO_ERRCODE_PREPROCESS_PREPROCESS_UNKNOWN_ERROR                                    1007001

/** 美颜参数非法，请检查传入的参数 */
#define ZEGO_ERRCODE_PREPROCESS_BEAUTIFY_OPTION_INVALID                                     1007005

/** 混响参数为 null，请检查传入的混响参数 */
#define ZEGO_ERRCODE_PREPROCESS_REVERB_PARAM_NULL                                           1007006

/** 变声器参数为 null，请检查传入的变声器参数 */
#define ZEGO_ERRCODE_PREPROCESS_VOICE_CHANGER_PARAM_NULL                                    1007007

/** 混响 room size 参数非法，正常范围 0.0 ~ 1.0 */
#define ZEGO_ERRCODE_PREPROCESS_REVERB_PARAM_ROOM_SIZE_INVALID                              1007011

/** 混响 reverberance 参数非法，正常范围 0.0 ~ 0.5 */
#define ZEGO_ERRCODE_PREPROCESS_REVERB_PARAM_REVERBERANCE_INVALID                           1007012

/** 混响 damping 参数非法，正常范围 0.0 ~ 2.0 */
#define ZEGO_ERRCODE_PREPROCESS_REVERB_PARAM_DAMPING_INVALID                                1007013

/** 混响 dry_wet_ratio 参数非法，正常范围 > 0.0 */
#define ZEGO_ERRCODE_PREPROCESS_REVERB_PARAM_DRY_WET_RATIO_INVALID                          1007014

/** 虚拟立体声 angle 参数非法，正常范围 0 ~ 180 */
#define ZEGO_ERRCODE_PREPROCESS_VIRTUAL_STEREO_ANGLE_INVALID                                1007015

/** 变声参数非法，正常范围 -8.0 ~ 8.0 */
#define ZEGO_ERRCODE_PREPROCESS_VOICE_CHANGER_PARAM_INVALID                                 1007016

/** 没有创建该媒体播放器实例 */
#define ZEGO_ERRCODE_MEDIAPLAYER_NO_INSTANCE                                                1008001

/** 媒体播放器播放失败，未加载资源文件 */
#define ZEGO_ERRCODE_MEDIAPLAYER_NO_FILE_PATH                                               1008003

/** 媒体播放器载入文件失败，不支持该格式文件 */
#define ZEGO_ERRCODE_MEDIAPLAYER_FILE_FORMAT_ERROR                                          1008005

/** 媒体播放器载入文件失败，路径不存在 */
#define ZEGO_ERRCODE_MEDIAPLAYER_FILE_PATH_NOT_EXISTS                                       1008006

/** 媒体播放器载入文件失败，解码错误 */
#define ZEGO_ERRCODE_MEDIAPLAYER_FILE_DECODE_ERROR                                          1008007

/** 媒体播放器载入文件失败，无可播放的音视频流 */
#define ZEGO_ERRCODE_MEDIAPLAYER_FILE_NO_SUPPORTED_STREAM                                   1008008

/** 媒体播放器播放失败，文件解析过程中出现错误 */
#define ZEGO_ERRCODE_MEDIAPLAYER_DEMUX_ERROR                                                1008010

/** 媒体播放器 Seek 失败，可能是还没加载文件 */
#define ZEGO_ERRCODE_MEDIAPLAYER_SEEK_ERROR                                                 1008016

/** 媒体播放器设置了该平台不支持的视频数据格式（如 iOS 平台下 CVPixelBuffer 不支持 NV21） */
#define ZEGO_ERRCODE_MEDIAPLAYER_PLATFORM_FORMAT_NOT_SUPPORTED                              1008020

/** 媒体播放器创建实例超过最大限制，最多可创建 4 个实例 */
#define ZEGO_ERRCODE_MEDIAPLAYER_EXCEED_MAX_COUNT                                           1008030

/** 媒体播放器内部错误 */
#define ZEGO_ERRCODE_MEDIAPLAYER_INNER_ERROR                                                1008099

/** 输入消息内容为空 */
#define ZEGO_ERRCODE_IM_CONTENT_NULL                                                        1009001

/** 输入消息内容超长，最长为 1024 字节 */
#define ZEGO_ERRCODE_IM_CONTENT_TOO_LONG                                                    1009002

/** 发送消息失败，可能是由于网络原因 */
#define ZEGO_ERRCODE_IM_SEND_FAILED                                                         1009010

/** 文件名后缀不支持，目前只支持 .mp4 或 .flv 文件名后缀，SDK 内部需要根据文件名后缀设置指定的录制格式 */
#define ZEGO_ERRCODE_RECORD_FILE_SUFFIX_NAME_FORMAT_NOT_SUPPORT                             1010002

/** 录制接口通用错误，一般为所传参数不合法 */
#define ZEGO_ERRCODE_RECORD_COMMON_LIVEROOM_API_ERROR                                       1010003

/** 指定录制文件路径太长 */
#define ZEGO_ERRCODE_RECORD_FILE_PATH_TOO_LONG                                              1010011

/** SDK 内部 VE 错误，请联系 ZEGO 技术人员解决 */
#define ZEGO_ERRCODE_RECORD_INNER_VE_ERROR                                                  1010012

/** 打开文件失败，不是合法的路径或没有文件权限 */
#define ZEGO_ERRCODE_RECORD_OPEN_FILE_FAILED                                                1010013

/** 写文件失败，可能是无写入文件权限 */
#define ZEGO_ERRCODE_RECORD_WRITE_FILE_ERROR                                                1010014

/** 剩余容量不够 */
#define ZEGO_ERRCODE_RECORD_NO_ENOUGH_SPARE_CAPACITY                                        1010017

/** 文件句柄异常 */
#define ZEGO_ERRCODE_RECORD_FILE_HANDLE_EXCEPTIONS                                          1010018

/** 输入输出异常 */
#define ZEGO_ERRCODE_RECORD_IO_EXCEPTIONS                                                   1010019

/** 自定义视频采集器未创建，请确保在收到 OnStart 回调后使用 */
#define ZEGO_ERRCODE_CUSTOMVIDEOIO_CAPTURER_NOT_CREATED                                     1011001

/** 自定义视频采集模块未开启，请确保在初始化配置中已开启自定义视频采集 */
#define ZEGO_ERRCODE_CUSTOMVIDEOIO_NO_CUSTOM_VIDEO_CAPTURE                                  1011002

/** 设置自定义采集/渲染失败，请确保在引擎启动前调用（确保在 `startPreview`/`startPublishingStream`/`startPlayingStream` 之前调用） */
#define ZEGO_ERRCODE_CUSTOMVIDEOIO_ENABLE_CUSTOM_IO_FAILED                                  1011003

/** 当前设置的自定义视频采集格式不支持该 API */
#define ZEGO_ERRCODE_CUSTOMVIDEOIO_NOT_SUPPORTED_FORMAT                                     1011010

/** 自定义视频渲染不支持当前设置的视频数据类型 */
#define ZEGO_ERRCODE_CUSTOMVIDEOIO_NOT_SUPPORTED_BUFFER_TYPE                                1011011

/** 不支持的自定义音频采集源类型 */
#define ZEGO_ERRCODE_CUSTOMAUDIOIO_UNSUPPORTED_AUDIO_SOURCE_TYPE                            1012001

/** 自定义音频采集功能未开启，请确保已开启指定推流通道的自定义音频 IO 功能 */
#define ZEGO_ERRCODE_CUSTOMAUDIOIO_CAPTURER_NOT_CREATED                                     1012002

/** 自定义音频渲染功能未开启，请确保已开启自定义音频 IO 功能 */
#define ZEGO_ERRCODE_CUSTOMAUDIOIO_RENDERER_NOT_CREATED                                     1012003

/** 设置自定义音频采集和渲染失败，请确保在引擎启动前调用（确保在 `startPreview`/`startPublishingStream`/`startPlayingStream` 之前调用） */
#define ZEGO_ERRCODE_CUSTOMAUDIOIO_ENABLE_CUSTOM_AUDIO_IO_FAILED                            1012004


#endif /* __ZEGO_EXPRESS_ERRCODE_H__ */
