//
//  zego-express-mediaplayer.h
//  ZegoExpressSDK
//
//  Created by lizhanpeng@ZEGO on 2019/9/27.
//

#ifndef __ZEGO_EXPRESS_MEDIAPLAYER_H__
#define __ZEGO_EXPRESS_MEDIAPLAYER_H__
#include "zego-express-errcode.h"
#include "zego-express-defines.h"

ZEGO_BEGIN_DECLS

typedef void(*zego_on_mediaplayer_state_update)(enum zego_mediaplayer_state state, zego_error error_code, enum zego_mediaplayer_instance_index instance_index, void* user_context);

typedef void(*zego_on_mediaplayer_network_event)(enum zego_mediaplayer_network_event event, enum zego_mediaplayer_instance_index instance_index, void* user_context);

typedef void(*zego_on_mediaplayer_playing_progress)(unsigned long long millisecond, enum zego_mediaplayer_instance_index instance_index, void* user_context);

typedef void(*zego_on_mediaplayer_seek_to_time_result)(zego_seq seq, zego_error error_code, enum zego_mediaplayer_instance_index instance_index, void* user_context);

typedef void(*zego_on_mediaplayer_load_resource_result)(zego_error error_code, enum zego_mediaplayer_instance_index instance_index, void* user_context);

typedef void(*zego_on_mediaplayer_audio_data)(const unsigned char* data, unsigned int data_length, const struct zego_audio_frame_param param, enum zego_mediaplayer_instance_index instance_index, void* user_context);

typedef void(*zego_on_mediaplayer_video_data)(const unsigned char** data, unsigned int* data_length, const struct zego_video_frame_param param, enum zego_mediaplayer_instance_index instance_index, void* user_context);


ZEGOEXP_API enum zego_mediaplayer_instance_index EXP_CALL zego_express_create_mediaplayer(void);

ZEGOEXP_API zego_error EXP_CALL zego_express_release_mediaplayer(enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_start(enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_stop(enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_pause(enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_resume(enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_load_resource(const char* path, enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API enum zego_mediaplayer_state EXP_CALL zego_express_mediaplayer_get_state(enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_seq EXP_CALL zego_express_mediaplayer_seek_to(unsigned long long millisecond, enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_set_volume(int volume, enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API int EXP_CALL zego_express_mediaplayer_get_volume(enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API unsigned long long EXP_CALL zego_express_mediaplayer_get_total_duration(enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API unsigned long long EXP_CALL zego_express_mediaplayer_get_current_duration(enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_mute_local_audio(bool mute, enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_set_player_canvas(struct zego_canvas *canvas, enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_enable_aux(bool enable, enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_enable_repeat(bool enable, enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_set_progress_interval(unsigned long long millisecond, enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_enable_audio_data(bool enable, enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API zego_error EXP_CALL zego_express_mediaplayer_enable_video_data(bool enable, enum zego_video_frame_format format, enum zego_mediaplayer_instance_index instance_index);

ZEGOEXP_API void EXP_CALL zego_register_mediaplayer_state_update_callback(zego_on_mediaplayer_state_update callback_func, void* user_context);

ZEGOEXP_API void EXP_CALL zego_register_mediaplayer_network_event_callback(zego_on_mediaplayer_network_event callback_func, void* user_context);

ZEGOEXP_API void EXP_CALL zego_register_mediaplayer_playing_progress_callback(zego_on_mediaplayer_playing_progress callback_func, void* user_context);

ZEGOEXP_API void EXP_CALL zego_register_mediaplayer_seek_to_result(zego_on_mediaplayer_seek_to_time_result callback_func, void* user_context);

ZEGOEXP_API void EXP_CALL zego_register_mediaplayer_load_resource_result(zego_on_mediaplayer_load_resource_result callback_func, void* user_context);

ZEGOEXP_API void EXP_CALL zego_register_mediaplayer_audio_data_callback(zego_on_mediaplayer_audio_data callback_func, void* user_context);

ZEGOEXP_API void EXP_CALL zego_register_mediaplayer_video_data_callback(zego_on_mediaplayer_video_data callback_func, void* user_context);

ZEGO_END_DECLS

#endif /* zego_express_mediaplayer_h */
